#coding: utf8;
############################################################################
#                                                                          #
#    This file 'exec_code.py'                                              #
#    is part of 'SPyRO: Simple Python Remote Objects'                      #
#    Copyright (C) 2004-2005 by Eric Sadit T�lez Avila                     #
#    Copyright (C) 2005-2006 by Eric Sadit T�lez Avila                     #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

def exec_code(filename, gvars, lvars):
    """ Execute the code inside |filename| with the globalvars |gvars| y
    |lvars.__dict__|, then lvars will become the object containing
    localvariables of the script |filename| as object attributes
    """
    f = file(filename)
    code = compile(f.read() + "\n", filename, 'exec')
    exec code in lvars.__dict__, lvars.__dict__
    f.close()

