#coding: iso-8859-1;
############################################################################
#                                                                          #
#    This file 'setup.py'                                                  #
#    is part of 'SPyRO: Simple Python Remote Objects'                      #
#    Copyright (C) 2004-2005 by Eric Sadit Tllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

#!/usr/bin/python
from distutils.core import setup
from distutils.extension import Extension
from Pyrex.Distutils import build_ext
import sre, os, sys

x = [
    'SPyRO/policies.py',
    'SPyRO/args.py',
    "SPyRO/SPyRO.py",
    "SPyRO/formats.py",
    #"SPyRO/exec_code.py",# No debe ser compilado
    'threadutils/ThreadPool.py',
    'threadutils/ServerInThread.py',
    'threadutils/PeriodicExecution.py',
    'shttp/sHTTP.py',
    'shttp/uri.py',
    ]

y = []
rex = []

for i in x:
    m = sre.sub(r".py$","",sre.sub(r'/','.',i))
    print m
    p = i + "x"
    rex.append(p)
    y.append(Extension(m, [p]))

setup(name="packages", version="0.1",
      packages=['threadutils','warn', 'shttp','SPyRO'],
      ext_modules = y,
      cmdclass= {'build_ext': build_ext}
)

