#!/usr/bin/python -OO
#coding: iso-8859-1;

############################################################################
#                                                                          #
#    This file 'pyidx.py'
#    is part of 'AFFAIRS'          #
#    Copyright (C) 2004-2005 by Eric Sadit Tllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

import sys,os
import sre
import SPyRO as spyro
import warn
warn = warn.Warn("server",warn.Warn.LOG_FILE,filename="output.x")

from threadutils import ThreadPool, ServerInThread

data=file("data").read()
datb=data[:len(data)/10]
#datc=data[:len(data)/2]
datc=data

class TransportTest0:
    def __init__(self):
        self.a="123456789"
        self.b="1"
        self.c="12"#(12345)
        self.d="123"#%(1,2,3,4,4,5,5,6,6,2,76,3,3,3,3,2,2,3,3,3,3,2,3,3)
        self.e="xxxxxxxxxxxx"
        self.f=datb
        self.g=datc
	self.mod50 = 1

    def statistics(self,x,y,kw1,kw2):
        l=0
        x=0
        a= None
        for i in self.__dict__:
            try:
                a = len(self.__dict__[i])
            except:
                a = 4
            l+=a
            x+=1.0
        self.mod50 += 1
	if self.mod50 % 50 == 0:
            raise Exception("A simple mod50 exception")
	if self.mod50 % 55 == 0:
            warn.debug("MOD55")
            raise "mod 55 exception"
        return "data-size: %d, number: %d"%(l,x)
    
try:
    import psyco
    psyco.full()
    #psyco.profile(memory=100)
    pass
except:
    print sys.stderr, "The psyco module is not present"

def startserver():
    addr=('0.0.0.0',4433)
    import socket
    ConnectionBroken = True
    numports = 10 
    while ConnectionBroken and numports:
        try:
            server=spyro.CommunicationServer(addr)#,ssl_privatekey_filename="/home/sadit/ssl/pandemonio.key", ssl_certificate_filename="/home/sadit/ssl/pandemonio.crt")
            #server=spyro.CommunicationServer(addr,ssl_privatekey_file="/home/sadit/ssl/apache.key", ssl_certificate_file="/home/sadit/ssl/apache.crt")
        except socket.error, e:
            warn.warn(e)
            addr = (addr[0], addr[1])
	    import time
	    print "Esperando 0.3 segundos para nuevo intento"
	    time.sleep(0.3)
            #addr = (addr[0], addr[1]+numports)
            numports-=0
        else:
            ConnectionBroken = False
    print "Hecho"
    basename = 'datafiles/db' + str(numports) # para pruebas
    
    TT0 = TransportTest0()
    
    #atexit.register(index.close)
    server['TT0'] = TT0
    server['Server'] = server
    
    try:
        print "Sirviendo en ", addr
        server.serve_forever()
    except Exception, e:
        warn.warn(e)

if __name__ == '__main__':
    import threadutils
    #threadutils.forkdaemon()
    startserver()
