#coding: iso-8859-1;
############################################################################
#                                                                          #
#    This file 'threadutils/ServerInThread.py'                             #
#    is part of 'SPyRO: Simple Python Remote Objects'                      #
#    Copyright (C) 2004-2005 by Eric Sadit Téllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

from threading import Thread, Lock, Condition
import thread, threading


try:
    True
except:
    __builtins__['True'] = 1
    __builtins__['False'] = 0

class ServerInThread(Thread):
    def __init__(self, ServerClass, *args, **kwargs):
        Thread.__init__(self)
        self.server = ServerClass(*args, **kwargs)
        self.running = True
        self.start()
    
    def close(self):
        self.running = False
        #self.server.socket.shutdown(2)
        #self.server.socket.close()
        self.server.close()
        
    def run(self):
        self.server.serve_forever()
        #while self.running:
        #    self.server.handle_request()

