#!/bin/sh

[ ! -d _pyrex ] && mkdir _pyrex
#cp -r shttp SPyRO.py threadutils warn _pyrex

tar --exclude html --exclude="\\.svn" --exclude="_pyrex" -cvf - * | tar -C _pyrex -xvf -

for i in $(find _pyrex -name "*.py")
do
  [ $(basename $i) = __init__.py ] && continue
  [ $(basename $i) = exec_code.py ] && continue
  [ $(basename $i) = http.py ] && continue
  [ $(basename $i) = codepools.py ] && continue
#  [ $(basename $i) = args.py ] && continue
  mv $i ${i}x
done
cp setup-pyrex.py _pyrex
cd _pyrex
python setup-pyrex.py build && sudo python setup-pyrex.py install
